Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.0.1.Final
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.optaplanner.core.impl.score.buildin.hardsoftdouble
Class HardSoftDoubleScoreDefinition

    java.lang.Object
      org.optaplanner.core.impl.score.definition.AbstractScoreDefinition<HardSoftDoubleScore>
          org.optaplanner.core.impl.score.buildin.hardsoftdouble.HardSoftDoubleScoreDefinition

All Implemented Interfaces:
  Serializable, ScoreDefinition<HardSoftDoubleScore>

    public class HardSoftDoubleScoreDefinition

extends AbstractScoreDefinition<HardSoftDoubleScore>

See Also:
  Serialized Form

Constructor Summary
`HardSoftDoubleScoreDefinition()`

Method Summary
`ScoreHolder` | `buildScoreHolder(boolean constraintMatchEnabled)`
`double` | `calculateTimeGradient(HardSoftDoubleScore startScore, HardSoftDoubleScore endScore, HardSoftDoubleScore score)` See explanation in `Termination.calculateSolverTimeGradient(DefaultSolverScope)`.
`double` | `getHardScoreTimeGradientWeight()`
`HardSoftDoubleScore` | `getPerfectMaximumScore()` The perfect maximum `Score` is the `Score` of which there is no better in any problem instance.
`HardSoftDoubleScore` | `getPerfectMinimumScore()` The perfect minimum `Score` is the `Score` of which there is no worse in any problem instance.
`Class<HardSoftDoubleScore>` | `getScoreClass()` Returns the `Class` of the actual `Score` implementation
`Score` | `parseScore(String scoreString)` Parses the `String` and returns a `Score`.
`void` | `setHardScoreTimeGradientWeight(double hardScoreTimeGradientWeight)` It's recommended to use a number which can be exactly represented as a double, such as 0.5, 0.25, 0.75, 0.125, ... but not 0.1, 0.2, ...
`void` | `setPerfectMaximumScore(HardSoftDoubleScore perfectMaximumScore)`
`void` | `setPerfectMinimumScore(HardSoftDoubleScore perfectMinimumScore)`

Methods inherited from class org.optaplanner.core.impl.score.definition.AbstractScoreDefinition
`formatScore`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### HardSoftDoubleScoreDefinition

    public HardSoftDoubleScoreDefinition()

Method Detail

### getHardScoreTimeGradientWeight

    public double getHardScoreTimeGradientWeight()

### setHardScoreTimeGradientWeight

    public void setHardScoreTimeGradientWeight(double hardScoreTimeGradientWeight)

  It's recommended to use a number which can be exactly represented as a double, such as 0.5, 0.25, 0.75, 0.125, ... but not 0.1, 0.2, ...

  Parameters:
    `hardScoreTimeGradientWeight` - 0.0 <= hardScoreTimeGradientWeight <= 1.0

### getPerfectMaximumScore

    public HardSoftDoubleScore getPerfectMaximumScore()

  Description copied from interface: `ScoreDefinition`
  The perfect maximum `Score` is the `Score` of which there is no better in any problem instance. This doesn't mean that the current problem instance, or any problem instance for that matter, could ever attain that `Score`. For example, most cases have a perfect maximum `Score` of zero, as most use cases only have negative constraints.

  Specified by:
    `getPerfectMaximumScore` in interface `ScoreDefinition<HardSoftDoubleScore>`
  Overrides:
    `getPerfectMaximumScore` in class `AbstractScoreDefinition<HardSoftDoubleScore>`
  Returns:
    null if not supported

### setPerfectMaximumScore

    public void setPerfectMaximumScore(HardSoftDoubleScore perfectMaximumScore)

### getPerfectMinimumScore

    public HardSoftDoubleScore getPerfectMinimumScore()

  Description copied from interface: `ScoreDefinition`
  The perfect minimum `Score` is the `Score` of which there is no worse in any problem instance. This doesn't mean that the current problem instance, or any problem instance for that matter, could ever attain such a bad `Score`. For example, most cases have a perfect minimum `Score` of negative infinity.

  Specified by:
    `getPerfectMinimumScore` in interface `ScoreDefinition<HardSoftDoubleScore>`
  Overrides:
    `getPerfectMinimumScore` in class `AbstractScoreDefinition<HardSoftDoubleScore>`
  Returns:
    null if not supported

### setPerfectMinimumScore

    public void setPerfectMinimumScore(HardSoftDoubleScore perfectMinimumScore)

### getScoreClass

    public Class<HardSoftDoubleScore> getScoreClass()

  Description copied from interface: `ScoreDefinition`
  Returns the `Class` of the actual `Score` implementation

  Returns:
    never null

### parseScore

    public Score parseScore(String scoreString)

  Description copied from interface: `ScoreDefinition`
  Parses the `String` and returns a `Score`.

  Parameters:
    `scoreString` - never null
  Returns:
    never null
  See Also:
    `ScoreDefinition.formatScore(Score)`

### calculateTimeGradient

    public double calculateTimeGradient(HardSoftDoubleScore startScore,
                                        HardSoftDoubleScore endScore,
                                        HardSoftDoubleScore score)

  Description copied from interface: `ScoreDefinition`
  See explanation in `Termination.calculateSolverTimeGradient(DefaultSolverScope)`.

  Parameters:
    `startScore` - never null
    `endScore` - never null
    `score` - never null
  Returns:
    between 0.0 and 1.0

### buildScoreHolder

    public ScoreHolder buildScoreHolder(boolean constraintMatchEnabled)

  Parameters:
    `constraintMatchEnabled` - true if `ScoreHolder.isConstraintMatchEnabled()` should be true
  Returns:
    never null

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.0.1.Final
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006-2013 JBoss by Red Hat. All Rights Reserved.